// PLEASE READ
// Many people have writen RobotBASIC to ask about multiple robots to play soccer etc.
// As we have said, our system only supports ONE robot.
// However, you don't need a complete robot with ALL the sensors to play soccer
// This program demonstrates the idea of how you can create soccer robots
//   DO NOT expect this program to be finished... it is only a beginning to give you the idea
// Using this idea, you can create several TYPES OF PLAYERS... with each type having its own game
//   plan.  Example, one player might head for the ball, another for a point in front of the goal
// Everything is played off the TABLE.... so if you plan to use this idea for real robots, the
//   sensors simply have to place information (such as the balls position) in the table.
//   In the same manner, each player would update the table with its current position.
//   The table becomes the way players communicate with each other. For example, 
//   one player can change the TYPE table entries for other players so that they take on a 
//   different role.  For example, a player heading for the ball might make the other players 
//   head for the goal by changing their TYPE
// You might try experiements... example... make all the players on one team normal, while have
//   one on the other team play back.  See which team tends to be better over time.
// There are MANY things that have to be improved in this game.  Remember it is only a SAMPLE 
//   program to show you how multiple robots can be handled in RobotBASIC.
//   The main plyers in this game always just chase the ball (some can hold back), but they do 
//   kick and pass based on a variety of parameters.  Remember, these ideas are just 
//   examples... so create your own...
// PLEASE let us know if you find this helpful or interesting.

main:
  dim Men[11,3]
  GreenScore=0
  BlueScore=0
  gosub Init
  gosub PlayGame
end

Init:
  clearscr
  // first draw goals and set goal X and Y
  rectangle 0,250,20,350,green,green
  setcolor white,green
  xytext 5,300,GreenScore
  rectangle 780,250,800,350,blue,blue
  setcolor white,blue
  xyText 785,300,BlueScore
  GgoalX = 20
  GgoalY = 300
  BgoalX = 780
  BgoalY = 300
  BallDir = 250
  BallSpeed = 15
  ManSpeed = 3
  // location 0 is the ball
  // locations 1-8 are men
  // the items at each location (0-2) are x,y, and type
  // type could be used to specify various types
  //    in this example the types are as follows
  //    0 - is the ball
  //    1 - green goalie
  //    2 - green player
  //    3 - blue goalie
  //    4 - blue player
  //    5 - green player that stays back
  //    6 - blue player that stays back
  // my simiplifed algorithm is as follows
  //    goalies will stay at the same x coordinate
  //      and move vertically based on the ball's position
  //      (but only when the ball is on their side of the field
  //    players will do one of two things
  //      if not at ball, move GENERALLY toward the ball with
  //         some randomness although some can stay back
  //      if at ball, kick it in a reasonable direction
  //         (don't assume my ideas on reasonable are best)
  //         Ball is kicked by setting BallSpeed and BallDir (direction)
  //         Ball will slow down as it moves...
  //    note: players ignore the other team in my algorithm

  size =5 // radius of men and ball

  // set up players
  Men[0,2] = 0  // ball
  Men[1,2] = 1  // green goalie
  Men[2,2] = 2  // green player
  Men[3,2] = 2  // green player
  Men[4,2] = 5  // green player that stays back
  Men[5,2] = 3  // blue goalie
  Men[6,2] = 4  // blue player
  Men[7,2] = 4  // blue player
  Men[8,2] = 6  // blue player that stays back
  // now choose random intial positions
  for i = 0 to 8
     if Men[i,2]=0 // ball
       Men[i,0] = Random(100)+300
       Men[i,1] = Random(100)+250
       clr = Red
     elseif Men[i,2] = 1 // green goalie
       Men[i,0] = 765
       Men[i,1] = 300
       clr = Green
     elseif Men[i,2] = 2 or Men[i,2]=5  // green player
       Men[i,0] = Random(200)+200
       Men[i,1] = Random(200)+200
       clr = Green
     elseif Men[i,2] = 3  // blue goalie
       Men[i,0] = 35
       Men[i,1] = 300
       clr = Blue
     elseif Men[i,2]=4 or Men[i,2]=6  // blue player
       Men[i,0] = Random(200)+400
       Men[i,1] = Random(200)+200
       clr = Blue
     endif
     x = Men[i,0]
     y = Men[i,1]
     circle x-size,y-size,x+size,y+size,clr,clr
  next
return

PlayGame:
 for t = 1 to 5 // play for 5 goals
    repeat
      gosub MoveAll
      gosub CheckGoal
    until goal
  next
return

MoveAll:
  for k = 0 to 8
     if k=0 
       i=0
     else
       i=random(8)+1 // let all items have the same chance of moving first
     endif
     x = Men[i,0]  // this just makes typing easier
     y = Men[i,1]  // x,y for current item (i)
     angle = BallDir *6.28/360
     //------------------------------------------------
     if Men[i,2]=0  // ball
       clr = Red
       newX = x+BallSpeed*Cos(angle)
       if newX<5 then newX=5
       if newX>795 then newX = 795
       newY = y+BallSpeed*Sin(angle)
       if newY<5 then newY=5
       if newY>595 then newY=595
       // erase old ball
       circle x-size,y-size,x+size,y+size,white,white
       // Save new ball position
       Men[i,0] = newX
       Men[i,1] = newY
       // slow ball down as it moves
       BallSpeed = BallSpeed*.95
       if BallSpeed<1 then BallSpeed=0
     //------------------------------------------------
     elseif Men[i,2] = 1  // green goalie
       clr = Green
       BallX=Men[0,0]
       BallY=Men[0,1]
       if BallX>400
         circle x-size,y-size,x+size,y+size,white,white
         if y<BallY and y<350 then y=y+2
         if y>BallY and y>250 then y=y-2
         Men[i,1] = y
         Gosub Check4ball
         if AtBall then BallDir = 180 \ BallSpeed=15
       endif
     //------------------------------------------------
     elseif Men[i,2] = 2  // green player           
       clr = Green
       // check if at ball
       // remember, x,y is man's position
       // set up ball's position
       BallX = Men[0,0]
       BallY = Men[0,1]
       gosub Check4ball
       if AtBall  // within ManSpeed
         // kick toward goal
         BallSpeed = 15
         if within(x,100,400)
           if within(y,200,400)
             BallDir = 150+Random(60)
           elseif y<=200
             BallDir = 90+Random(60)
           else
             BallDir = 200+Random(60)
           endif
         elseif x>400
           BallDir = 45+Random(270)
         else
            if y>3000 
              BallDir = Random(20)
            else
              BallDir = 340+Random(20)
            endif
         endif          
       else
         // move this man toward ball
         // x,y are the man's position
         // erase old man
         circle x-size,y-size,x+size,y+size,white,white
         // create a bias to move toward appropriate goal
         if x<400 and x>BallX
           bias = -2
         else
           bias = 2
         endif
         if BallX > x 
           x=x+Random(10)+bias
         else
           x=x-Random(10)+bias
         endif
         if BallY > y
           y=y+Random(10)+1
         else
           y=y-Random(10)-1 
         endif
         // redraw man
         circle x-size,y-size,x+size,y+size,clr,clr
         // save new position
         Men[i,0] = x
         Men[i,1] = y
       endif  
     //------------------------------------------------   
     elseif Men[i,2] = 3 // blue goalie    
       clr = Blue
       BallX=Men[0,0]
       BallY=Men[0,1]
       if BallX<400
         circle x-size,y-size,x+size,y+size,white,white
         if y<BallY and y<350 then y=y+2
         if y>BallY and y>250 then y=y-2
         Men[i,1] = y
         Gosub Check4ball
         if AtBall then BallDir = 0 \ BallSpeed=15
       endif
     //------------------------------------------------  
     elseif Men[i,2] = 4  // blue player
       clr = blue    
       // check if at ball
       // remember, x,y is man's position
       // set up ball's position
       BallX = Men[0,0]
       BallY = Men[0,1]
       gosub Check4ball
       if AtBall  // within ManSpeed
         // kick toward goal
         BallSpeed = 15
         if within(x,400,700)
           if within(y,200,400)
             BallDir = 330+Random(60)
             if BallDir>=360 then BallDir=BallDir-360
           elseif y<=200
             BallDir = 60-Random(60)
           else
             BallDir = Random(60)
           endif
         elseif x<400
           BallDir = 315+Random(180)
           if BallDir>=360 then BallDir=BallDir-360
         else
            if y>300 
              BallDir = 160+Random(20)
            else
              BallDir = 180+Random(20)
            endif
         endif     
       else
         // move this man toward ball
         // x,y are the man's position
         // erase old man
         circle x-size,y-size,x+size,y+size,white,white
         // create a bias to move toward appropriate goal
         if x<400 and x<BallX
           bias = 2
         else
           bias = -2
         endif
         if x<BallX 
           x=x+Random(10)+bias
         else
           x=x-Random(10)+bias
         endif
         if BallY > y
           y=y+Random(10)+1
         else
           y=y-Random(10)-1
         endif
         // redraw man
         circle x-size,y-size,x+size,y+size,clr,clr
         // save new position
         Men[i,0] = x
         Men[i,1] = y
       endif    
     //------------------------------------------------  
     elseif Men[i,2] = 5  // green player that stays back
       clr = Green
       // check if at ball
       // remember, x,y is man's position
       // set up ball's position
       BallX = Men[0,0]
       BallY = Men[0,1]
       gosub Check4ball
       if AtBall  // within ManSpeed
         // kick toward goal
         BallSpeed = 15
         if within(x,100,400)
           if within(y,200,400)
             BallDir = 150+Random(60)
           elseif y<=200
             BallDir = 90+Random(60)
           else
             BallDir = 200+Random(60)
           endif
         elseif x>400
           BallDir = 45+Random(270)
         else
            if y>3000 
              BallDir = Random(20)
            else
              BallDir = 340+Random(20)
            endif
         endif          
       else
         // move this man toward ball
         // x,y are the man's position
         // erase old man
         circle x-size,y-size,x+size,y+size,white,white
         // create a bias to move toward appropriate goal
         if x<400 and x>BallX
           bias = -2
         else
           bias = 2
         endif
         if BallX > x 
           x=x+Random(10)+bias
         else
           x=x-Random(10)+bias
         endif
         if x>500 then x=500  // only line that changed for this type
         if BallY > y
           y=y+Random(10)+1
         else
           y=y-Random(10)-1 
         endif
         // redraw man
         circle x-size,y-size,x+size,y+size,clr,clr
         // save new position
         Men[i,0] = x
         Men[i,1] = y
       endif 
        
     //------------------------------------------------  
     elseif Men[i,2] = 6  // blue player  that stays back
       clr = blue    
       // check if at ball
       // remember, x,y is man's position
       // set up ball's position
       BallX = Men[0,0]
       BallY = Men[0,1]
       gosub Check4ball
       if AtBall  // within ManSpeed
         // kick toward goal
         BallSpeed = 15
         if within(x,400,700)
           if within(y,200,400)
             BallDir = 330+Random(60)
             if BallDir>=360 then BallDir=BallDir-360
           elseif y<=200
             BallDir = 60-Random(60)
           else
             BallDir = Random(60)
           endif
         elseif x<400
           BallDir = 315+Random(180)
           if BallDir>=360 then BallDir=BallDir-360
         else
            if y>300 
              BallDir = 160+Random(20)
            else
              BallDir = 180+Random(20)
            endif
         endif     
       else
         // move this man toward ball
         // x,y are the man's position
         // erase old man
         circle x-size,y-size,x+size,y+size,white,white
         // create a bias to move toward appropriate goal
         if x<400 and x<BallX
           bias = 2
         else
           bias = -2
         endif
         if x<BallX 
           x=x+Random(10)+bias
         else
           x=x-Random(10)+bias
         endif
         if x<300 then x=300
         if BallY > y
           y=y+Random(10)+1
         else
           y=y-Random(10)-1
         endif
         // redraw man
         circle x-size,y-size,x+size,y+size,clr,clr
         // save new position
         Men[i,0] = x
         Men[i,1] = y
       endif    

        
     endif
     x = Men[i,0]
     y = Men[i,1]
     circle x-size,y-size,x+size,y+size,clr,clr
  next
return

Check4ball:
  // x,y is man's position
  // BallX,BallY is ball's position
  if within(x-BallX,-ManSpeed,ManSpeed) and within(y-BallY,-ManSpeed, ManSpeed)
    AtBall = true
  else
    AtBall = false
  endif
Return

CheckGoal:
  // Note: goal is now scored if the ball gets in the area... even
  // if it enters from the side (which would be impossible in a real game)
  setcolor black,white
  BallX = Men[0,0]
  BallY = Men[0,1]
  if BallX<30 and within (BallY,260,340)
    // Green goal
    goal = green
    GreenScore = GreenScore+1
  elseif BallX>770 and within(BallY,260,340)
    // Blue goal
    goal = blue
    BlueScore = BlueScore+1
  else
    goal = false
  endif
  if goal >0
    for g= 1 to 5
      setcolor white,black
      xyText 360,300," G O A L "
      delay 100
      setcolor Black,white
      xyText 360,300," G O A L "
      delay 100
    next
    delay 1000
    gosub Init
  endif  
Return
  